#!/usr/bin/perl

# Webadmin CGI configuration

require "config.pl";

## Main Program ##########################################
use CGI;
$query = new CGI;
#print $query->header;


$cmd = $query->param('cmd');
$at = $query->param('at');
$item = $query->param('item');

if($cmd=~/add/i){
	if($at=~/test/i){
		&add_test;
	}
	elsif($at=~/shutdown/i){
		&add_shutdown;
	}
}
elsif($cmd=~/remove/){
	if($at=~/test/i){
		&remove_test($item);
	}
	elsif($at=~/shutdown/i){
		&remove_shutdown($item);
	}
}

$location = "webadmin.pl";
print "Location: $location\n\n"; exit(); 

## Sub routine ##########################################

sub add_test{
	my @lines;
	my $i = 0;
	my $temp;

	open(READ_FI,"$conf_file_path$conf_file_name");
	@lines = <READ_FI>;
	close(READ_FI);

	open(WRITE_FI,">$conf_file_path$conf_file_name");
	while($i<@lines){
		if($lines[$i]=~/^[ ]*UPSTEST/){
			while($lines[$i]=~/\\[ ]*$/){
				print WRITE_FI $lines[$i];
				$i++;
			}
			$temp = $lines[$i];
			chomp($temp);
			print WRITE_FI $temp."\\\n";
			print WRITE_FI $query->param('TEST_TIME_DAY')." ".$query->param('TEST_TIME_MONTH')." ".$query->param('TEST_TIME_HOUR').":".$query->param('TEST_TIME_MIN')."\n";
		} else{
			print WRITE_FI $lines[$i];
		  }
		$i++;
	}
	close(WRITE_FI);
}

sub add_shutdown{
	my @lines;
	my $i = 0;
	my $temp;

	open(READ_FI,"$conf_file_path$conf_file_name");
	@lines = <READ_FI>;
	close(READ_FI);

	open(WRITE_FI,">$conf_file_path$conf_file_name");
	while($i<@lines){
		if($lines[$i]=~/^[ ]*SHUTDOWN/){
			while($lines[$i]=~/\\[ ]*$/){
				print WRITE_FI $lines[$i];
				$i++;
			}
			$temp = $lines[$i];
			chomp($temp);
			print WRITE_FI $temp."\\\n";
			print WRITE_FI $query->param('SHUTDOWN_TIME_DAY')." ".$query->param('SHUTDOWN_TIME_MONTH')." ".$query->param('SHUTDOWN_TIME_HOUR').":".$query->param('SHUTDOWN_TIME_MIN')." to ";
			print WRITE_FI $query->param('TO_TIME_DAY')." ".$query->param('TO_TIME_MONTH')." ".$query->param('TO_TIME_HOUR').":".$query->param('TO_TIME_MIN')."\n";
		} else{
			print WRITE_FI $lines[$i];
		  }
		$i++;
	}
	close(WRITE_FI);
}

sub remove_test{
	my @lines;
	my @buffer;
	my $i = 0;
	my $j;
	my $temp;
	my $count;
	my $item = @_[0];

	open(READ_FI,"$conf_file_path$conf_file_name");
	@lines = <READ_FI>;
	close(READ_FI);

	chomp(@lines);

	open(WRITE_FI,">$conf_file_path$conf_file_name");
	while($i<@lines){
		if($lines[$i]=~/^[ ]*UPSTEST/){
			while($lines[$i]=~/\\[ ]*$/){
				push(@buffer,$lines[$i]);
				$i++;
			}
			push(@buffer,$lines[$i]);
			$temp = join(' ',@buffer);
			$temp =~ s/\\/ /g;
			@buffer = split(' ',$temp);
			$j = 1; $count = 0;
			print WRITE_FI "UPSTEST ";
			while($j<@buffer){
				if($count != $item){
					print WRITE_FI "\\\n";
					print WRITE_FI "$buffer[$j] $buffer[$j+1] $buffer[$j+2]";
				}
				$count++;
				$j = $j+3;
			}
			print WRITE_FI "\n";
		} else{
			print WRITE_FI $lines[$i]."\n";
		  }
		$i++;		
	}
	close(WRITE_FI);
}

sub remove_shutdown{
	my @lines;
	my @buffer;
	my $i = 0;
	my $j;
	my $temp;
	my $count;
	my $item = @_[0];

	open(READ_FI,"$conf_file_path$conf_file_name");
	@lines = <READ_FI>;
	close(READ_FI);

	chomp(@lines);

	open(WRITE_FI,">$conf_file_path$conf_file_name");
	while($i<@lines){
		if($lines[$i]=~/^[ ]*SHUTDOWN MANUAL/){
			while($lines[$i]=~/\\[ ]*$/){
				push(@buffer,$lines[$i]);
				$i++;
			}
			push(@buffer,$lines[$i]);
			$temp = join(' ',@buffer);
			$temp =~ s/\\/ /g;
			@buffer = split(' ',$temp);
			$j = 2; $count = 0;
			print WRITE_FI "SHUTDOWN MANUAL ";
			while($j<@buffer){
				if($count != $item){
					print WRITE_FI "\\\n";
					print WRITE_FI "$buffer[$j] $buffer[$j+1] $buffer[$j+2] $buffer[$j+3] $buffer[$j+4] $buffer[$j+5] $buffer[$j+6]";
				}
				$count++;
				$j = $j+7;
			}
			print WRITE_FI "\n";
		} else{
			print WRITE_FI $lines[$i]."\n";
		  }
		$i++;		
	}
	close(WRITE_FI);
}
